/**
* @file cloud_effect.h
*/

#ifndef _CLOUD_EFFECT
#define _CLOUD_EFFECT

#include "vector.h"
#include "vector2D.h"

#include "weather_effect.h"

#include "sound_buffer.h"
#include "sound_source.h"

class CloudEffect : public WeatherEffect
{
	public:
		CloudEffect(const TiXmlElement* root = NULL);
		virtual ~CloudEffect();

		virtual void loadParams(const TiXmlElement* root);

		virtual bool init();

		virtual bool activate();
		virtual bool deactivate();

		virtual void draw() const;
		virtual void tick(float dt);

	private:
		// Basic noise map 32x32
		float map32[32 * 32];

		// The cloud map
		float map256[256 * 256];

		char texture[256][256][3];       //Temporary array to hold texture RGB values 

		float noise(int x, int y, int random);
		void setNoise(float  *map);
		float interpolate(float x, float y, float  *map);
		void overlapOctaves(float  *map32, float  *map256);
		void expFilter(float  *map);
};

#endif  /* _CLOUD_EFFECT */
